﻿version
6.50
0
frmSun
0
Sub designer
addform(frmSun,"Sun","",220,220,220)@
addlabel(frmsun,lblNoon,137,150,50,20,"noon",220,220,220,0,0,0,True,True,9)@
addcheckbox(frmsun,cbxDaylight,65,118,160,25,"Daylight saving time",220,220,220,0,0,0,True,True,False,9)@
addlabel(frmsun,lblTimeZone,170,65,65,20,"Time zone",220,220,220,0,0,0,True,True,9)@
addtextbox(frmsun,txtTimeZone,185,90,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addlabel(frmsun,lblLength0,20,175,45,20,"Length",220,220,220,0,0,0,True,True,9)@
addlabel(frmsun,lblLength,65,175,70,20,"",200,200,200,0,0,0,True,True,9)@
addlabel(frmsun,lblTransit0,20,150,45,20,"Transit",220,220,220,0,0,0,True,True,9)@
addlabel(frmsun,lblTransit,65,150,70,20,"",200,200,200,0,0,0,True,True,9)@
addlabel(frmsun,lblSet,65,225,70,20,"",200,200,200,0,0,0,True,True,9)@
addlabel(frmsun,lblRise,65,200,70,20,"",200,200,200,0,0,0,True,True,9)@
addlabel(frmsun,lblSet0,20,225,45,20,"Sunset",220,220,220,0,0,0,True,True,9)@
addlabel(frmsun,lblRise0,15,200,50,20,"Sunrise",220,220,220,0,0,0,True,True,9)@
addtextbox(frmsun,txtLat,65,60,95,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmsun,txtLong,65,90,95,22,"",255,255,255,0,0,0,True,True,False,9)@
addlabel(frmsun,lblLat,20,60,45,20,"Lat",220,220,220,0,0,0,True,True,9)@
addlabel(frmsun,lblLong,20,90,45,20,"Long",220,220,220,0,0,0,True,True,9)@
addbutton(frmsun,btnCalc,180,25,45,23,"Calc",212,208,200,0,0,0,True,True,9)@
addlabel(frmsun,lblDay,140,5,20,20,"D",220,220,220,0,0,0,True,True,9)@
addlabel(frmsun,lblMonth,90,5,20,20,"M",220,220,220,0,0,0,True,True,9)@
addlabel(frmsun,lblYear,30,5,20,20,"Y",220,220,220,0,0,0,True,True,9)@
addtextbox(frmsun,txtDay,130,25,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmsun,txtMonth,85,25,30,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(frmsun,txtYear,20,25,50,22,"",255,255,255,0,0,0,True,True,False,9)@
End Sub
@EndOfDesignText@
Sub Globals
	'Declare the global variables here.
	Public Lat
	Public Long
	Public TimeZone
	Public DayLight
	Public Day
	Public Month
	Public Year
	Public SunTransit
	Public SunRise
	Public SunSet
	Public SunLength
	
	Lat=34
	Long=31
	TimeZone=-2
	DayLight=0
	Day=DateD
	Month=DateM
	Year=DateY
	SunTransit=0
	SunRise=0
	SunSet=0
	SunLength=0
	
	n=0
	D_R=cPI/180

	file=AppPath&"\SunRiseSet.ini"
End Sub

Public Sub Show
	frmSun.Text="Sun Rise Set V 1.0"
	If FileExist(file) Then
		LoadIni
		If DayLight=1 Then
			cbxDaylight.Checked=True
		Else
			cbxDaylight.Checked=False
		End If
	End If
	txtDay.Text=Day
	txtMonth.Text=Month
	txtYear.Text=Year
	txtLong.Text=Long
	txtLat.Text=Lat
	txtTimeZone.Text=TimeZone
	frmSun.Show
	btnCalc_Click
End Sub

Sub btnCalc_Click
	Day=txtDay.Text
	Month=txtMonth.Text
	Year=txtYear.Text
	Lat=txtLat.Text
	Long=txtLong.Text
	TimeZone=txtTimeZone.Text

	CalcSunRiseSet(Day,Month,Year,TimeZone,Daylight,Lat,Long)

	lblLength.Text=HourToHM(SunLength)
	lblTransit.Text=HourToHM(SunTransit)
	lblSet.Text=HourToHM(SunSet)
	lblRise.Text=HourToHM(SunRise)
End Sub

Sub txtLong_LostFocus
	Long=txtLong.Text
	If Abs(Long)>179 Then
		Long=179*Long/Abs(Long)
		txtLong.Text=Long
	End If
	If Long>0 Then
		TimeZone=-Int((Long+7.5)/15)
	Else
		TimeZone=Int((-Long+7.5)/15)
	End If
	txtTimeZone.Text=TimeZone
End Sub

Sub txtLat_LostFocus
	Lat=txtLat.Text
	If Abs(Lat)>179 Then
		Lat=179*Lat/Abs(Lat)
		txtLat.Text=Lat
	End If
End Sub

Sub cbxDaylight_Click
	If cbxDaylight.Checked=True Then
		Daylight=1
	Else
		Daylight=0
	End If
	btnCalc_Click
End Sub

Public Sub CalcSunRiseSet(Dd,Mm,Yy,Tz,Dl,lLat,lLong)
	Dim n,J,Jd,M,MR,C,l,Jt,d,w0
' Dd = day
' Mm = month  1 to 12
' Yy = year
' Tz = time zone
' Dl = day light saving 0 or 1
' lLat = latitude north positive  south negative
' lLong = longitude west positive  east negative
		
	Jd=CalcJulianDate(Dd,Mm,Yy)
	n=Jd-0.0009-lLong/360
	n=Round(n,0)
	J=0.0009+lLong/360+n
	M=(357.5291+0.98560028*J) Mod 360
	MR=M*D_R
	C=1.9148*Sin(MR)+0.02*Sin(2*MR)+0.0003*Sin(3*MR)
	l=(M+102.9372+C+180) Mod 360
	lR=l*D_R
	Jt=J+0.0053*Sin(MR)-0.0069*Sin(2*lR)
	Jt=Jt-Int(Jt)
	If Jt>0.5 Then
		Jt=Jt-1
	End If
	d=ASin(Sin(lR)*Sin(23.45*D_R))
	w0=ACos((Sin(-0.83*D_R)-Sin(lLat*D_R)*Sin(d))/Cos(lLat*D_R)/Cos(d))
	w0=w0/D_R/15
	SunLength=2*w0
	SunTransit=(Jt)*24+12+TimeZone+Daylight
	SunRise=SunTransit-w0
	SunSet=SunTransit+w0
End Sub

Public Sub CalcJulianDate(Dd,Mm,Yy)
	Dim jd,a,y,m
	
	a=(14-Mm)/12
	y=Yy+4800-a
	m=Mm+12*a-3
	jd=Int(Dd+(153*m+2)/5+365*y+y/4-y/100+y/400)-32046-2451545
	Return jd
End Sub

Sub HourToHM(H)
	Dim Hh,Hm
	Hh=Int(H)
	If StrLength(Hh)=1 Then
		Hh="0"&Hh
	End If
	
	Hm=Int((H-Hh)*60)
	If StrLength(Hm)=1 Then
		Hm="0"&Hm
	End If
	Return Hh&":"&Hm
End Sub

Sub HourToHMS(H)
	Dim Hh,Hm,Hm0,Hs
	Hh=Int(H)
	If StrLength(Hh)=1 Then
		Hh="0"&Hh
	End If
	
	Hm0=(H-Hh)*60
	Hm=Int(Hm0)
	If StrLength(Hm)=1 Then
		Hm="0"&Hm
	End If

	Hs=Int((Hm0-Hm)*60)
	If StrLength(Hs)=1 Then
		Hs="0"&Hs
	End If
	
	Return Hh&":"&Hm&":"&Hs
End Sub

Sub LoadIni
	FileOpen(c1,file,cRead,,)
	Lat=FileRead(c1)
	Long=FileRead(c1)
	TimeZone=FileRead(c1)
	DayLight=FileRead(c1)
	FileClose(c1)
End Sub

Sub SaveIni
	FileOpen(c1,file,cWrite,,)
	FileWrite(c1,Lat)
	FileWrite(c1,Long)
	FileWrite(c1,TimeZone)
	FileWrite(c1,DayLight)
	FileClose(c1)
End Sub

Sub frmSun_Close
	SaveIni
End Sub